<template>
	<transition name="toast">
		<div
				v-if="notification.display"
				data-testid="notification"
				class="ts-notification py-5 has-text-centered has-text-white"
				:class="typeDetail.widgetClass"
				@click="clearNotification"
		>
			{{ $t(notification.message) }}
			<td-icon
					:class="typeDetail.iconClass"
					:icon="typeDetail.icon"
			/>
		</div>
	</transition>
</template>

<script lang="ts">
import { faCheckCircle, faExclamationTriangle, faInfoCircle } from '@fortawesome/free-solid-svg-icons';
import { useStore } from 'vuex';
import { computed } from 'vue';
import { NotificationType } from 'src/store';

export default {
	name: 'TsNotification',
	setup() {
		const store = useStore();
		const clearNotification = () => store.dispatch('clearNotification');
		const notification = computed(() => store.state.notification);
		const notificationType = computed(() => store.state.notification.type);
		const typeDetail = computed(() => {
			switch (notificationType.value) {
				case NotificationType.ERROR:
					return { icon: faExclamationTriangle, iconClass: 'has-text-error', widgetClass: 'has-background-error-transparent' };
				case NotificationType.WARNING:
					return { icon: faExclamationTriangle, iconClass: 'has-text-warning', widgetClass: 'has-background-warning-transparent' };
				case NotificationType.SUCCESS:
					return { icon: faCheckCircle, iconClass: 'has-text-white', widgetClass: 'has-background-success-transparent' };
				default:
					return { icon: faInfoCircle, iconClass: 'has-test-blue', widgetClass: 'has-background-info-transparent' };
			}
		});
		return { notification, typeDetail, clearNotification };
	},
};
</script>

<style lang="scss" scoped>
@import "src/style/utils";
.ts-notification {
	position: fixed;
	backdrop-filter: blur(6px);
	left: 50%;
	transform: translateX(-50%);
	min-width: 45vw;
	bottom: 0;
	border-radius: 1.2em;
	margin-bottom: 3.7em;
}
.toast-enter-from {
	transform: translate(-50%, 170%);
}
.toast-enter-active {
	transition: all 0.7s;
}
.toast-leave-to {
	transform: translate(-50%, 170%);
}
.toast-leave-active {
	transition: all 0.7s;
}
</style>
